Home | History | Annotate | Download | only in tests
      1 #!/bin/sh
      2 #
      3 # Ensure that strace can detach from stopped processes.
      4 #
      5 # Copyright (c) 2013-2015 Dmitry V. Levin <ldv (at] altlinux.org>
      6 # All rights reserved.
      7 #
      8 # Redistribution and use in source and binary forms, with or without
      9 # modification, are permitted provided that the following conditions
     10 # are met:
     11 # 1. Redistributions of source code must retain the above copyright
     12 #    notice, this list of conditions and the following disclaimer.
     13 # 2. Redistributions in binary form must reproduce the above copyright
     14 #    notice, this list of conditions and the following disclaimer in the
     15 #    documentation and/or other materials provided with the distribution.
     16 # 3. The name of the author may not be used to endorse or promote products
     17 #    derived from this software without specific prior written permission.
     18 #
     19 # THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
     20 # IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
     21 # OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
     22 # IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
     23 # INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
     24 # NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
     25 # DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
     26 # THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
     27 # (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
     28 # THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
     29 
     30 . "${srcdir=.}/init.sh"
     31 
     32 run_prog_skip_if_failed \
     33 	kill -0 $$
     34 
     35 check_prog sleep
     36 
     37 $STRACE -d -enone / > /dev/null 2> "$LOG"
     38 if grep -x "[^:]*strace: PTRACE_SEIZE doesn't work" "$LOG" > /dev/null; then
     39 	skip_ "PTRACE_SEIZE doesn't work"
     40 fi
     41 
     42 set -e
     43 
     44 rm -f "$LOG"
     45 ./set_ptracer_any sleep $((2*$TIMEOUT_DURATION)) > "$LOG" &
     46 
     47 while ! [ -s "$LOG" ]; do
     48 	kill -0 $! 2> /dev/null ||
     49 		fail_ 'set_ptracer_any sleep failed'
     50 	$SLEEP_A_BIT
     51 done
     52 
     53 tracee_pid=$!
     54 kill -STOP $tracee_pid
     55 
     56 cleanup()
     57 {
     58 	set +e
     59 	kill $tracee_pid
     60 	kill -CONT $tracee_pid
     61 	wait $tracee_pid 2> /dev/null
     62 	return 0
     63 }
     64 
     65 rm -f "$LOG"
     66 $STRACE -p $tracee_pid 2> "$LOG" &
     67 
     68 while ! grep -F "Process $tracee_pid attached" "$LOG" > /dev/null; do
     69 	kill -0 $! 2> /dev/null || {
     70 		cleanup
     71 		dump_log_and_fail_with "$STRACE -p failed to attach"
     72 	}
     73 	$SLEEP_A_BIT
     74 done
     75 
     76 while ! grep -F -e '--- stopped by ' "$LOG" > /dev/null; do
     77 	kill -0 $! 2> /dev/null || {
     78 		cleanup
     79 		dump_log_and_fail_with "$STRACE -p missed stop notifications"
     80 	}
     81 	$SLEEP_A_BIT
     82 done
     83 
     84 kill -INT $!
     85 wait $!
     86 
     87 grep -F "Process $tracee_pid detached" "$LOG" > /dev/null || {
     88 	cleanup
     89 	dump_log_and_fail_with "$STRACE -p failed to detach"
     90 }
     91 
     92 if [ -f /proc/self/status ]; then
     93 	$SLEEP_A_BIT
     94 	test -d /proc/$tracee_pid || {
     95 		cleanup
     96 		dump_log_and_fail_with 'tracee died after detach'
     97 	}
     98 	grep '^State:.*T (stopped)' < /proc/$tracee_pid/status > /dev/null || {
     99 		grep '^State:' < /proc/$tracee_pid/status
    100 		cleanup
    101 		dump_log_and_fail_with 'tracee is not group-stopped after detach'
    102 	}
    103 fi
    104 
    105 cleanup
    106 exit 0
    107